﻿--[[
    Name:           Titan Recount
	Description:	Titan Panel interface for Recount.
       Recount is authored by Elsia and Cryect.
	Author:         Suddendeath2000
	Version:        3.3.1
    --]]

TPRecountID = "Recount"
TPRecountVersion = "3.3.1"
TPRecountC1 = "|cffffffff"
TPRecountC2 = "|cff993300"
TPRecountC3 = "|cff00ff00"
TPRecountC4 = "|cffffcc00"
TitanPanelRecountRealtime = "Realtime Graphs"
TitanPanelRecountRaid = "Raid Graphs"
TitanPanelRecountWindow = "Window Type"
TitanPanelRecountDataType = "Data Type"

function TitanPanelRecountButton_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(TPRecountC1.."Titan Panel "..TPRecountC2.."["..TPRecountID.."] "..TPRecountC1.."v"..TPRecountC2..TPRecountVersion.." "..TPRecountC1.."by |cff999999Suddendeath2000")
       
    self.registry = {
		id = TPRecountID,
	    version = TPRecountVersion,
        menuText = TPRecountID,        
        category = "Interface",
        tooltipTitle = TPRecountC4..TPRecountID,
		tooltipTextFunction = "TitanPanelRecountButton_GetTooltipText",
        icon = "Interface\\AddOns\\TitanRecount\\TitanRecount",
        iconButtonWidth = 16,        
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,  
            ShowTooltipText = 1,
            ShowMenuOptions = 1,
            ShowAdvancedMenus = 1,           
            }}     
            
    tinsert(TITAN_PANEL_NONMOVABLE_PLUGINS, TPRecountID)
end

function TitanPanelRecountButton_GetTooltipText()
    return TPRecountC3.."Double Left-Click to Toggle Main Window\n"..TPRecountC3.."Right-click to Open Options" 
end

function TitanPanelRecountButton_OnDoubleClick(button)
    if button == "LeftButton" then
      if Recount.MainWindow:IsVisible() then Recount.MainWindow:Hide()
        else Recount.MainWindow:Show();Recount:RefreshMainWindow()
    end  
  end
end

function TitanPanelRightClickMenu_PrepareRecountMenu()   
    if  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelRecountRealtime )then
      TitanPanelRightClickMenu_AddTitle(TitanPanelRecountRealtime, UIDROPDOWNMENU_MENU_LEVEL);
      
    info = {}
    info.text = "Realtime FPS"   
    info.func =  function() Recount:CreateRealtimeWindow("FPS","FPS","") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
    
    info = {}
    info.text = "Realtime Latency"   
    info.func =  function() Recount:CreateRealtimeWindow("Latency","LAG","") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
    
    info = {}
    info.text = "Upstream Traffic"   
    info.func =  function() Recount:CreateRealtimeWindow("Upstream Traffic","UP_TRAFFIC","") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Downstream Traffic"   
    info.func =  function() Recount:CreateRealtimeWindow("Downstream Traffic","DOWN_TRAFFIC","") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Available Bandwidth"   
    info.func =  function() Recount:CreateRealtimeWindow("Bandwidth Available","AVAILABLE_BANDWIDTH","") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelRecountRaid )then
      TitanPanelRightClickMenu_AddTitle(TitanPanelRecountRaid, UIDROPDOWNMENU_MENU_LEVEL);
      
    info = {}
    info.text = "Raid Damage Per Second"   
    info.func =  function() Recount:CreateRealtimeWindow("!RAID","DAMAGE","Raid DPS") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Raid Damage Taken Per Second"   
    info.func =  function() Recount:CreateRealtimeWindow("!RAID","DAMAGETAKEN","Raid DTPS") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Raid Healing Per Second"   
    info.func =  function() Recount:CreateRealtimeWindow("!RAID","HEALING","Raid HPS") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Raid Healing Taken Per Second"   
    info.func =  function() Recount:CreateRealtimeWindow("!RAID","HEALINGTAKEN","Raid HTPS") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
      
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelRecountWindow )then
      TitanPanelRightClickMenu_AddTitle(TitanPanelRecountWindow, UIDROPDOWNMENU_MENU_LEVEL)
      
    info = {}
    info.text = "Damage Done"   
    info.checked = Recount.db.profile.MainWindowMode == 1    
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(1) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "DPS"   
    info.checked = Recount.db.profile.MainWindowMode == 2
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(2) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Friendly Fire" 
    info.checked = Recount.db.profile.MainWindowMode == 3
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(3) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Damage Taken"   
    info.checked = Recount.db.profile.MainWindowMode == 4
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(4) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Healing Done"   
    info.checked = Recount.db.profile.MainWindowMode == 5
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(5) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Healing Taken" 
    info.checked = Recount.db.profile.MainWindowMode == 6
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(6) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Overhealing Done" 
    info.checked = Recount.db.profile.MainWindowMode == 7
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(7) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Deaths"   
    info.checked = Recount.db.profile.MainWindowMode == 8
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(8) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "DOT Uptime"   
    info.checked = Recount.db.profile.MainWindowMode == 9
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(9) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "HOT Uptime"   
    info.checked = Recount.db.profile.MainWindowMode == 10
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(10) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Activity"
    info.checked = Recount.db.profile.MainWindowMode == 11
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(11) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Dispels"   
    info.checked = Recount.db.profile.MainWindowMode == 12
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(12) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Dispelled"   
    info.checked = Recount.db.profile.MainWindowMode == 13
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(13) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Interrupts" 
    info.checked = Recount.db.profile.MainWindowMode == 14
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(14) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Ressers"
    info.checked = Recount.db.profile.MainWindowMode == 15
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(15) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "CC Breakers"   
    info.checked = Recount.db.profile.MainWindowMode == 16
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(16) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Mana Gained"   
    info.checked = Recount.db.profile.MainWindowMode == 17
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(17) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Energy Gained"   
    info.checked = Recount.db.profile.MainWindowMode == 18
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(18) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    info = {}
    info.text = "Rage Gained"
    info.checked = Recount.db.profile.MainWindowMode == 19
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(19) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Runic Power Gained"
    info.checked = Recount.db.profile.MainWindowMode == 20
    info.func =  function() Recount.MainWindow:Show() Recount:SetMainWindowMode(20) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)      
      
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelRecountDataType )then
      TitanPanelRightClickMenu_AddTitle(TitanPanelRecountDataType, UIDROPDOWNMENU_MENU_LEVEL)  
    
    info = {}
    info.text = "Overall Data"
    info.checked = Recount.db.profile.CurDataSet == "OverallData"
    info.func =  function() Recount.db.profile.CurDataSet = "OverallData" print("Recount: Shows Overall Data") end 
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
      
    info = {}
    info.text = "Current Fight"
    info.checked = Recount.db.profile.CurDataSet == "LastFightData"
    info.func =  function() Recount.db.profile.CurDataSet = "LastFightData" print("Recount: Shows Current Fight Data") end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
    
    else
    
    TitanPanelRightClickMenu_AddTitle(TPRecountID)
    TitanPanelRightClickMenu_AddSpacer()   
    
    info = {}
    info.text = "Realtime Graphs";
    info.value = TitanPanelRecountRealtime;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
    
    info = {}
    info.text = "Raid Graphs";
    info.value = TitanPanelRecountRaid;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Window Type";
    info.value = TitanPanelRecountWindow;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Data Type";
    info.value = TitanPanelRecountDataType;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    TitanPanelRightClickMenu_AddSpacer()
    
    info = {}
    info.text = "Report Window"
    info.func = function() Recount:ShowReport("Main",Recount.ReportData) end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)    
    
    info = {}
    info.text = "Config Window"
    info.func = function()  Recount:ShowConfig() end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    info = {}
    info.text = "Reset Data"
    info.func = function() Recount:ShowReset() end
    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end 
end